require "defines"
require("config")

local north = defines.direction.north -- direction: 4
local east = defines.direction.east -- direction: 6
local south = defines.direction.south -- direction: 0
local west = defines.direction.west -- direction: 2

color = {
	white = {r = 1, g = 1, b = 1},
	lightred = {r = 1, g = 0.5, b = 0.5},
	green = {r = 0, g = 1, b = 0},
}

--------------------------------------------------------------------------------------

function on_init()	
	global.active = global.active or active
	global.quantingredients = global.quantingredients or quantingredients
	global.quantingredientsMAX  = global.quantingredientsMAX or quantingredientsMAX
end

script.on_init( on_init )

--------------------------------------------------------------------------------------

function on_tick(event)
	update_gui()
end

script.on_event(defines.events.on_tick, on_tick)

--------------------------------------------------------------------------------------

function on_creation( event )

	if global.active == true then
		local _Entity = event.created_entity
		
		if _Entity.name == "logistic-chest-requester" then
			
			-- FIX LONG INSERTER
			
			local UP = false; --cod in function "assemblymachines" = 1
			local LEFT = false; --cod in function "assemblymachines" = 2
			local DOWN = false; --cod in function "assemblymachines" = 3
			local RIGHT = false; --cod in function "assemblymachines" = 4
			
			--NOTE: if you have a long inserter two houses forward, every front whether you have insensor.
			--NOTA: caso tenha um insensor longo duas casas a frente, a cada da frente no importa se tenha insensor.
			
			-- END FIX LONG INSERTER
			
			local _Position = _Entity.position
			
			-- FIX LONG INSERTER
			
			local _longinserter = game.surfaces["nauvis"].find_entity("long-handed-inserter", {_Position.x, _Position.y - 2}) -- UP
			if _longinserter ~= nil then
				if _longinserter.direction == 4 then
					UP = true
					assemblymachines(_Position.y - 3, _Position.x, _Entity, 1)
				end
			end
			
			local _longinserter = game.surfaces["nauvis"].find_entity("long-handed-inserter", {_Position.x - 2, _Position.y}) -- LEFT
			if _longinserter ~= nil then
				if _longinserter.direction == 2 then
					LEFT = true
					assemblymachines(_Position.y, _Position.x - 3, _Entity, 2)
				end
			end
			
			local _longinserter = game.surfaces["nauvis"].find_entity("long-handed-inserter", {_Position.x, _Position.y + 2}) -- DOWN
			if _longinserter ~= nil then
				if _longinserter.direction == 0 then
					DOWN = true
					assemblymachines(_Position.y + 3, _Position.x, _Entity, 3)
				end
			end
			
			local _longinserter = game.surfaces["nauvis"].find_entity("long-handed-inserter", {_Position.x + 2, _Position.y}) -- RIGHT
			if _longinserter ~= nil then
				if _longinserter.direction == 6 then
					RIGHT = true
					assemblymachines(_Position.y, _Position.x + 3, _Entity, 4)
				end
			end
			
			-- END FIX LONG INSERTER
			
			local entities = game.surfaces["nauvis"].find_entities_filtered{area = {{_Position.x - 1,_Position.y - 1}, {_Position.x + 1,_Position.y + 1}}, type= "inserter"}
			for _, entity in pairs(entities) do
				
				--the inserter can just get the chest that is two houses behind
				--o insersor s consegue pegar do ba que estiver duas casas atrs
				if entity.name ~= "long-handed-inserter" then
					if UP == false and entity.direction == 4 and entity.position.y == _Position.y - 1 and entity.position.x == _Position.x then
						assemblymachines(_Position.y - 2, _Position.x, _Entity, 0)				
					elseif LEFT == false and entity.direction == 2 and entity.position.y == _Position.y and entity.position.x == _Position.x - 1 then
						assemblymachines(_Position.y, _Position.x - 2, _Entity, 0)
					elseif DOWN == false and entity.direction == 0 and entity.position.y == _Position.y + 1 and entity.position.x == _Position.x then
						assemblymachines(_Position.y + 2, _Position.x, _Entity, 0)
					elseif RIGHT == false and entity.direction == 6 and entity.position.y == _Position.y and entity.position.x == _Position.x + 1 then
						assemblymachines(_Position.y, _Position.x + 2, _Entity, 0)	
					end
				end
			end
			
		end
	end
end

script.on_event(defines.events.on_built_entity, on_creation )
script.on_event(defines.events.on_robot_built_entity, on_creation )

--------------------------------------------------------------------------------------

function assemblymachines(y, x, _Entity, _LongInsensor)
	
	-- The long inserter works with the immediately following machine or skipping a house, so have to check for each of the four sides
	-- O insersor longo funciona com a mquina imediatamente seguinte ou pulando uma casa, assim tem que verificar para cada um dos quatro lados
	
	-- UP --cod in function "assemblymachines" = 1
	-- LEFT --cod in function "assemblymachines" = 2
	--DOWN --cod in function "assemblymachines" = 3
	-- RIGHT --cod in function "assemblymachines" = 4
			
	local _Assembly = nil
	
	if _LongInsensor > 0 then
		
		if _LongInsensor == 1 then
			_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-1',{x,y})
			if _Assembly == nil then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-1',{x,y-1})
			end
		elseif _LongInsensor == 2 then
			_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-1',{x,y})
			if _Assembly == nil then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-1',{x-1,y})
			end
		elseif _LongInsensor == 3 then
			_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-1',{x,y})
			if _Assembly == nil then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-1',{x,y+1})
			end
		elseif _LongInsensor == 4 then
			_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-1',{x,y})
			if _Assembly == nil then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-1',{x+1,y})
			end
		end
		
		if _Assembly == nil then
			
			if _LongInsensor == 1 then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-2',{x,y})
				if _Assembly == nil then
					_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-2',{x,y-1})
				end
			elseif _LongInsensor == 2 then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-2',{x,y})
				if _Assembly == nil then
					_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-2',{x-1,y})
				end
			elseif _LongInsensor == 3 then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-2',{x,y})
				if _Assembly == nil then
					_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-2',{x,y+1})
				end
			elseif _LongInsensor == 4 then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-2',{x,y})
				if _Assembly == nil then
					_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-2',{x+1,y})
				end
			end
			
		end
		if _Assembly == nil then
			
			if _LongInsensor == 1 then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-3',{x,y})
				if _Assembly == nil then
					_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-3',{x,y-1})
				end
			elseif _LongInsensor == 2 then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-3',{x,y})
				if _Assembly == nil then
					_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-3',{x-1,y})
				end
			elseif _LongInsensor == 3 then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-3',{x,y})
				if _Assembly == nil then
					_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-3',{x,y+1})
				end
			elseif _LongInsensor == 4 then
				_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-3',{x,y})
				if _Assembly == nil then
					_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-3',{x+1,y})
				end
			end
		end
		
	else
		_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-1',{x,y})
		if _Assembly == nil then
			_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-2',{x, y})					
		end
		if _Assembly == nil then
			_Assembly = game.surfaces["nauvis"].find_entity('assembling-machine-3',{x, y})					
		end
	end
	
	
	
	if _Assembly ~= nil then
		sub_assemblymachines(y, x, _Entity, _Assembly)
	end
end

--------------------------------------------------------------------------------------

function sub_assemblymachines(y, x, _Entity, _Assembly)

	local _Recipe = _Assembly.recipe
	if _Recipe ~= nil then
		local _ingredients = _Recipe.ingredients
		local _index = 1
		
		local slotsempty = 0
		for x = 1,10 do
			if _Entity.get_request_slot(x) == nil then
				slotsempty = 11 - x
				break
			end
		end
		
		if slotsempty > 0 then
			local exists = 0
			
			for _, ingredient in pairs(_ingredients) do
				if ingredient.type == "item" then
					
					for x = 1,10-slotsempty do
						if _Entity.get_request_slot(x).name == ingredient.name then
							exists = exists + 1
							break
						end
					end
					
					if exists > 0 then break end
					
				end
				
			end
			
			if slotsempty+exists >= tablelength(_ingredients) then
				updaterequester(_ingredients, _Entity)
			else
				game.player.print({"__quantivalida__"})
			end
		end
	end

end

--------------------------------------------------------------------------------------

function updaterequester(_ingredients, _Entity)

	for _, ingredient in pairs(_ingredients) do
		if ingredient.type == "item" then
			
			for x = 1,10 do
				
				if _Entity.get_request_slot(x) == nil then
					_Entity.set_request_slot({name=ingredient.name, count=(ingredient.amount * global.quantingredients)}, x)
					break
				else
					if _Entity.get_request_slot(x).name == ingredient.name then
						local countactual = _Entity.get_request_slot(x).count
						_Entity.set_request_slot({name=ingredient.name, count=((ingredient.amount * global.quantingredients) + countactual)}, x)
						break
					end
				end				
			end
		end
	end
end

--------------------------------------------------------------------------------------

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

--------------------------------------------------------------------------------------
function on_gui_click(event)

	if event.element.name == "button_active" then
		if global.active then
			global.active = false
		else
			global.active = true
		end
	end
	
	if event.element.name == "button_minus" then
		if global.quantingredients > 1 then
			global.quantingredients = global.quantingredients - 1
		end
	end
	
	if event.element.name == "button_more" then
		if global.quantingredients < global.quantingredientsMAX then
			global.quantingredients = global.quantingredients + 1
		end
	end
	
	update_gui()
end

script.on_event(defines.events.on_gui_click, on_gui_click )

--------------------------------------------------------------------------------------
function build_gui()
	local player, guifs
	for _, player in pairs(game.players) do
		if player.connected and player.gui.top.autorequestassemblys == nil then
			guifs = player.gui.top.add({type = "frame", name = "autorequestassemblys", caption = "", direction = "horizontal", style = "timebar_frame_style"})
			guifs.add({type = "button", name = "button_active", caption = "AR: Y", font_color = color.green, style = "timebar_button_style"})				
			guifs.add({type = "button", name = "button_minus", caption = "-" , font_color = color.white, style = "timebar_button_style"})
			guifs.add({type = "button", name = "button_value", caption = tostring( global.quantingredients ) , font_color = color.white, style = "timebar_button_style"})
			guifs.add({type = "button", name = "button_more", caption = "+" , font_color = color.white, style = "timebar_button_style"})
		end
	end
end
	
--------------------------------------------------------------------------------------
function update_gui()
	local player
	
	build_gui()
	
	if global.active then
		for _, player in pairs(game.players) do
			if player.connected then
				player.gui.top.autorequestassemblys.button_active.caption = "AR: Y"
				player.gui.top.autorequestassemblys.button_active.style.font_color = color.green
			end
		end
	else
		for _, player in pairs(game.players) do
			if player.connected then
				player.gui.top.autorequestassemblys.button_active.caption = "AR: N"
				player.gui.top.autorequestassemblys.button_active.style.font_color = color.lightred
			end
		end
	end	
	
	for _, player in pairs(game.players) do
		if player.connected then
			player.gui.top.autorequestassemblys.button_value.caption = tostring( global.quantingredients )
		end
	end
	
end

--------------------------------------------------------------------------------------